package hcavsc.av

class Label(val str: String) extends AnyVal {
  override def toString = s"Label($str)"
}

object Label {
  def apply(s: String): Label =
    new Label(s)
}

class MyFirstTests {
  def combineLabels(l: Label, r: Label): Label =
    Label(l.str + r.str)
    
  def printLabels(): Unit = {
    val fst = Label("hello")
    val snd = Label("world")
    val lbls = List(fst, snd)
    lbls.map{x => Label(x.str + "Aux")}
    (fst, snd)
    identity(fst)
    println(fst.str)
    println(snd.str)
  }
}

case class Labelled[A](lbl: Label, a: A)
