package hcavsc.broken

object Labels {
  sealed abstract class LabelImpl {
    type T
    def subst[F[_]](fs: F[String]): F[T]
    def apply(s: String): T
    def unwrap(lbl: T): String
  }
  
  // oops, you forgot  `: LabelImpl`
  val Label = new LabelImpl {
    type T = String
    override def subst[F[_]](fs: F[String]) = fs
    override def apply(s: String) = s
    override def unwrap(lbl: T) = lbl
  }

  type Label = Label.T
}

import Labels._

object Tests {
  val lbl: Label = "hi"
  lbl: String
  implicitly[Label =:= String]
}
